import React from 'react';
import { StyleSheet, Text, View, TouchableOpacity, AsyncStorage, Alert, StatusBar } from 'react-native';


const sendData = async () => {
    try {
        let response = await fetch('https://radegast.janhrabal.com', {
            method: "POST"
        });
        let responseJson = await response.json();
        return responseJson.movies;
    } catch (error) {
        console.error(error);
    }
}

const storeRating = async (rating) => {
    let key = new Date().getTime();
    await AsyncStorage.setItem(JSON.stringify(key), JSON.stringify({
        rating
    }));
}


class App extends React.PureComponent {

    constructor(props) {
        super(props);
        this.state = {
            mode: 'rating',
            stats: {},
            statsLoading: false
        };
    }

    componentDidMount() {
        //this.timer = setInterval(sendData, 10000);
    }

    componentWillUnmount() {
        //clearInterval(this.timer);
    }


    renderRating() {
        const buttons = [];
        for (let i = 5; i; i--) {
            let text = "";
            for (let j = 0; j < i; j++) {
                text += "*";
            }
            buttons.push(<TouchableOpacity key={ i } onPress={ this.onPress(i) }>
                <Text>{ text }</Text>
            </TouchableOpacity>
            );
        }

        return (
            <View style={styles.container}>
                <Text>Radegast Zóna</Text>
                { buttons }
            </View>
        );
    }


    onPress(rating) {
        return async () => {
            try {
                this.setState({ mode: "info" });
                await storeRating(rating);
                setTimeout(() => this.setState({ mode: "rating" }), 2000);

                // TODO
                let keys = await AsyncStorage.getAllKeys();
                let s = keys.join(",\n");

                Alert.alert("stats", s);

            } catch (e) {
                console.error(e);
                this.setState({ mode: "rating" });
            }  
        }
    }


    renderResults() {
        return null;
    }


    renderInfo() {
        return <Text>XXX</Text>;
    }


    render() {
        let { mode } = this.state;

        let content = null;

        switch (mode) {
            case 'results':
                content = this.renderResults();
                break;
            case 'info':
                content = this.renderInfo();
                break;
            default:
                content = this.renderRating();

        }

        return (
            <View style={styles.container}>
                <StatusBar hidden />
                { content }
            </View>
        );
    }


}


export default App;


const styles = StyleSheet.create({
    container: {
        flex: 1,
        backgroundColor: '#fff',
        alignItems: 'center',
        justifyContent: 'center',
    },
});
